
#include <stdexcept>

#include "complex.h"

std::ostream& math:: operator << ( std::ostream& out, complex c ) 
{
   if( c. re == 0 )
   {
      if( c. im > 0 )
      {
         if( c.im != 1 )
            out << c.im;
         out << 'i';
      }

      if( c. im < 0 )
      {
         if( c.im != -1 )
            out << c.im;
         else
            out << '-';
         out << 'i';
      }

      if( c.im == 0 )
         out << '0';
      return out;
   }

   out << c. re;

   if( c. im > 0 )
   {
      out << '+';
      if( c. im != 1 )
         out << c. im;
      out << 'i';
   }

   if( c. im < 0 )
   {
      out << '-';
      if( c. im != -1 )
         out << -c. im;
      out << 'i';
   }

   return out;
}


#if 0 
// Should be replaced by a higher-order method.

math::complex math::integrate( complex f( complex ),
                               const std::list< complex > & path,
                               double h( complex ) )
{
   complex sum;
      // This will be the result of the integration. 

   if( path.length( ) < 2 )
      throw std::logic_error( "path must have length 2 at least" );

   std::list< complex > :: const_iterator p1 = path. begin( );
   std::list< complex > :: const_iterator p2 = p1; 
   ++ p2;

   while( p2 != path. end( ))
   {
      std::cout << "integrating segment from " << *p1
                << " to " << *p2 << "\n";
      // We integrate the segment from *p1 to *p2.

      complex unitstep = *p2 - *p1;
      unitstep /= unitstep. length( );

      double distance = ( *p2 - *p1 ). length( );
 
      complex x = *p1;
      double s = h(x);  
     
      while( distance >= s )
      {

         complex step = unitstep * s; 
#if 0 
         std::cout << "x = " << x << ", f(x) = " << f(x) << "\n";
         std::cout << "h(x) = " << s << ", step = " << step << "\n";
         std::cout << "sum = " << sum << "\n"; 
         std::cout << "\n";
#endif 

         sum += 0.5 * ( f(x) + f(x+step) ) * step;  

         x += step;          
         distance -= s; 
         
         s = h(x);
      }

      // One should not forget to make the last step, because distance
      // may be close to s, due to rounding errors. 
      // In that case, there is a distance, proportional to s, between
      // x and *p2. 

      // The last step must end at *p2, so we compute: 

      complex step = *p2 - x; 

      sum += 0.5 * ( f(x) + f(x+step ) ) * step;
      x += step; 

      ++ p1; 
      ++ p2;
   } 
   return sum;
}

#endif 
