
#ifndef MATH_RANDOM_INCLUDED
#define MATH_RANDOM_INCLUDED   1

#include "../linalg/vector.h"

namespace math
{

   namespace random
   {

      unsigned int randomunsigned( unsigned int upperbound );
         // Produce a random number between 0 and upperbound.

      double randomdouble( );
         // Produce a random number between 0 and 1. 

      linalg::vector randominunitcube( );
         // Produces a random vector, whose components lie between
         // -1 and 1. The quality of the random vector is not high.

      linalg::vector randominunitsphere( );
         // Produces a random vector with length( ) < 1.

      linalg::vector randominunitcircle( );
         // Produces a random vector with Z = 0 and length( ) < 1. 
   } 

}

#endif
          
