
// Written by Hans de Nivelle, January 2017.

#include "state.h"


void physics::state::integrate( const state_acc& deriv, double h )
{
   linalg::spinspeed vvvv1 = 
      vvvv + h * linalg::spinspeed( deriv. alpha, deriv. acc ); 

   // This step is taken from Heun's method:

   xxxx.x0 += 0.5 * h * ( vvvv.v0 + vvvv1.v0 );
   xxxx.q = 
      linalg::quaternion::rotation( 0.5 * h * ( vvvv.omega + vvvv1. omega )) 
         *
      xxxx.q; 

   // This is just Euler's method:

   vvvv = vvvv1;
}


