
// Written by Hans de Nivelle, January 2017.

#ifndef PHYSICS_STATE_INCLUDED
#define PHYSICS_STATE_INCLUDED  1

#include <iostream>
#include "state_acc.h"

#include "../linalg/rototrans.h"
#include "../linalg/spinspeed.h"

namespace physics
{
   struct state 
   {
      linalg::rototrans xxxx;    // linear and angular. 
      linalg::spinspeed vvvv;    // linear and angular. 

      state( const linalg::rototrans& xxxx, const linalg::spinspeed& vvvv )
         : xxxx{ xxxx }, vvvv{ vvvv }
      { 
      }

#if 0
      state( const linalg::vector& position,
             const linalg::vector& speed,
             const linalg::quaternion& orientation, 
             const linalg::vector& omega = {0,0,0} )
         : xxxx{ orientation, position },
           vvvv{ omega, speed } 
      { }
#endif 

      void integrate( const state_acc& deriv, double h );
   };


   inline 
   std::ostream& operator << ( std::ostream& out, const state& st )
   {
      out << "State:\n";
      out << "   xxxx:     " << st. xxxx << "\n";
      out << "   vvvv:     " << st. vvvv << "\n";
      return out;
   }
}

#endif


